<template>
  <doc-content-with-toc>
    <h1>Grids and flex boxes</h1>

    <h2>Grids</h2>
    <p>
      Use one of the provided helpers to quickly have a grid.
      Note that these grids are responsive and will change their layouts on smaller screens.
    </p>

    <template v-for="(cells, klass) in grids" :key="klass">
      <h3><code>{{ klass }}</code></h3>

      <div :class="klass">
        <div v-for="i in cells*3" :key="i" class="-doc-outline">Cell {{ i }}</div>
      </div>
    </template>

    <h2>Flexbox</h2>

    <p>
      Make a flexbox with <code>.-flex</code> and use variants to customize it.
    </p>

    <div class="-flex">
      <div v-for="i in 8" :key="i" class="-doc-outline">Flex cell {{ i }}</div>
    </div>

    <p>
      Make a column flexbox with <code>.-flex-column</code> and use variants to customize it.
    </p>

    <div class="-flex-column">
      <div v-for="i in 8" :key="i" class="-doc-outline">Flex cell {{ i }}</div>
    </div>

    <h3>Inline flexboxes</h3>

    <p>
      Make an inline flexbox with <code>.-inline-flex</code> and use variants to customize it.
    </p>

    <div class="-inline-flex">
      <div v-for="i in 8" :key="i" class="-doc-outline">Flex cell {{ i }}</div>
    </div>

    <p>
      Make an inline column flexbox with <code>.-inline-flex-column</code> and use variants to customize it.
    </p>

    <div class="-inline-flex-column">
      <div v-for="i in 8" :key="i" class="-doc-outline">Flex cell {{ i }}</div>
    </div>

    <h3>Cell classes</h3>
    <p>Grow the cell with <code>.-flex--grow</code></p>

    <div class="-flex">
      <div v-for="i in 3" :key="i" :class="`-doc-outline ${i%2===0 ? '-flex--grow' : ''}`">
        Flex cell {{ i }}
        <template v-if="i % 2 === 0">(with <code>.-flex--grow</code>)</template>
      </div>
    </div>

    <p>Prevent resize with <code>.-flex--none</code></p>

    <h3>Inline flexboxes</h3>
    <p>Use <code>.-inline-flex</code> to create an inline flexbox.</p>

    <p>
      Exemple: Lorem ipsum dolor
      <span class="-inline-flex">
        <span class="-doc-outline">sit amet,<br>consectetur</span>
        <span class="-doc-outline">adipisicing elit</span>
      </span>
      adipisicing elit. Asperiores blanditiis doloribus dolorum ea eius est excepturi explicabo facilis harum incidunt, minus obcaecati, porro quia rem, sequi sit unde veritatis vitae?
    </p>

    <h2>Common helpers</h2>

    <p>These helpers works on both grids and flex boxes</p>

    <h3>Container modifiers</h3>

    <p>Container modifiers apply to the grid or flex container</p>

    <section v-for="helper in helpers.block" :key="helper" class="-mtl">
      <h4><code>.{{ helper }}</code></h4>

      <h5>Grid example</h5>
      <div class="-grid-3 -doc-outline--alt" :class="helper">
        <div class="-doc-outline">multi<br>line<br>content</div>
        <div class="-doc-outline">single line</div>
        <div class="-doc-outline">another single line</div>
      </div>

      <h5>Flex example</h5>
      <div class="-flex -doc-outline--alt" :class="helper">
        <div class="-doc-outline">multi<br>line<br>content</div>
        <div class="-doc-outline">single line</div>
        <div class="-doc-outline">another single line</div>
      </div>
    </section>

    <h3>Element modifiers</h3>

    <p>Container modifiers apply to the grid or flex item</p>

    <section v-for="helper in helpers.element" :key="helper">
      <h4><code>.{{ helper }}</code></h4>
      <p>Grid example</p>
      <div class="-grid-3 -doc-outline--alt">
        <div class="-doc-outline">multi<br>line<br>content</div>
        <div class="-doc-outline" :class="helper">{{ helper }}</div>
        <div class="-doc-outline">single line</div>
      </div>

      <p>Flex example</p>
      <div class="-flex -doc-outline--alt">
        <div class="-doc-outline">multi<br>line<br>content</div>
        <div class="-doc-outline" :class="helper">{{ helper }}</div>
        <div class="-doc-outline">single line</div>
      </div>
    </section>
  </doc-content-with-toc>
</template>

<script>
import { DocContentWithToc } from '../../../../documentation_system/components/index.js'

const grids = {
  // class: base cells count
  '-grid-2': 2,
  '-grid-3': 3,
  '-grid-4': 4,
  '-grid-1-2': 2,
  '-grid-1-3': 2,
  '-grid-1-4': 2,
  '-grid-2-1': 2,
}

const helpers = {
  element: [
    '-align-self-end',
    '-align-self-start',
  ],
  block: [
    '-align-items-start',
    '-align-items-baseline',
    '-align-items-end',
    '-gap',
    '-justify-content-start',
    '-justify-content-center',
    '-justify-content-end',
    '-justify-content-right',
    '-justify-content-left',
  ],
}

export default {
  name: 'GridsView',
  components: { DocContentWithToc },
  data () {
    return {
      grids,
      helpers,
    }
  },
  created () {
    this.$setTitle('Grids and flex')
  },
}
</script>
